src/config/routes.rb
Rails.application.routes.draw do
  resources :courses
  get 'admin/users'

  get '/dashboard', to: 'dashboard#index', as: :dashboard

  resources :users, only: [:new, :create]
  get '/users/profile', to: 'users#profile'
  get '/users/password', to: 'users#password'
  put '/users/change_password', to: 'users#change_password'
  put '/users/:id/change_role_to/:role', to: 'users#change_role', as: :users_change_role

  get '/sign_up', to: 'users#new', as: :sign_up

  resources :sessions, only: [:new, :create, :destroy]
  get '/sign_in', to: 'sessions#new', as: :sign_in
  delete '/sign_out', to: 'sessions#destroy', as: :sign_out

  get '/about', to: 'static_pages#about', as: :about
  get '/contact', to:'static_pages#contact', as: :contact

  resources :quizzes do
    member do
      get :attempt
      post :result
    end
  end

  root 'static_pages#home'


  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

src/app/models/user.rb
class User < ApplicationRecord
  authenticates_with_sorcery!

  has_and_belongs_to_many :courses, class_name: "Course"

  validates :password, length: { minimum: 3 }, if: :new_user?

  validates :password, confirmation: true
  validates :email, uniqueness: true
  validates :email, uniqueness: true, email_format: { message: 'has invalid format' }

  enum role: {
    student: 0,
    teacher: 1,
    admin: 2
  }

  def change_password!(new_password)
    self.send(:"#{sorcery_config.password_attribute_name}=", new_password)
    sorcery_adapter.save
  end

  def role?(role_name)
    role == role_name
  end

  private
  def new_user?
    new_record?
  end
end

src/app/controllers/users_controller.rb
class UsersController < ApplicationController
  skip_before_action :require_login, only: [:new, :create]
  skip_authorization_check only: [:new, :create]

  def new
    @user = User.new
  end

  def create
    @user = User.new(user_params)
    if @user.save
      login(params[:user][:email], params[:user][:password])
      flash[:success] = 'Welcome!'
      redirect_to dashboard_path
    else
      render 'new'
    end
  end

  def password
    render 'change_password'
    authorize! :update, User
  end

  def change_password
    @user = User.find(current_user.id)

    return if @user.blank?

    @user.password_confirmation = params[:user][:password_confirmation]
    if @user.change_password!(params[:user][:password])
      flash[:success] = 'Password was successfully updated.'
      redirect_to dashboard_path
    else
      render 'change_password'
    end
      authorize! :update, User
  end

  def change_role
    user = User.find(params[:id])

    if user.update(role: params[:role])
      flash[:success] = 'Role updated!'
      redirect_to admin_users_path
    else
      flash[:danger] = 'Role update failed!'
      redirect_to admin_users_path
    end
    authorize! :update, User
  end

  def profile
    @user = User.find(current_user.id)
    authorize! :read, User
  end

  private

  def user_params
    params.require(:user).permit(:email, :password, :password_confirmation, :username)
  end
end

src/app/helpers/users_helper.rb
module UsersHelper
end

src/app/views/users/change_password.html.erb
<h1>Change your password</h1>

<%= form_for current_user, url: users_change_password_path, method: :put do |f| %>
  <div class="form-group">
    <%= f.label :password %>
    <%= f.password_field :password, class: 'form-control', required: true %>
  </div>

  <div class="form-group">
    <%= f.label :password_confirmation %>
    <%= f.password_field :password_confirmation, class: 'form-control', required: true %>
  </div>

  <%= f.submit 'Change password', class: 'btn btn-primary btn-lg' %>
<% end %>

src/app/views/users/new.html.erb
<h1>Registration</h1>

<%= form_for @user do |f| %>
    <div class="form-group">
      <%= f.label :username %>
      <%= f.text_field :username, class: 'form-control', required: true %>
    </div>

    <div class="form-group">
      <%= f.label :email %>
      <%= f.email_field :email, class: 'form-control', required: true %>
    </div>
    <div class="form-group">
      <%= f.label :password %>
      <%= f.password_field :password, class: 'form-control', required: true %>
    </div>
    <div class="form-group">
      <%= f.label :password_confirmation %>
      <%= f.password_field :password_confirmation, class: 'form-control', required: true %>
    </div>

    <%= f.submit 'Register', class: 'btn btn-primary btn-lg' %>
<% end %>

src/app/views/users/profile.html.erb
<h1>Profile</h1>
<p>Username: <%= @user.username %></p>
<p>Email: <%= @user.email %></p>
<p>Role: <%= @user.role %></p>